EDIT - bug #10186

Problems with session handling in taxeditor
11/17/2022 02:34 PM - Katja Luther

Status: Closed Start date:

Priority: New Due date:

Assignee: Katja Luther % Done: 60%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.35

Severity: normal Found in Version:

Description

This ticket should contain everything done/tested to fix the session handling problems in the editor, like unsaved changes in

typedesignations, secundum references or somewhere else (see related tickets)

Related issues:

Related to EDIT - bug #10111: Data loss e.g. when entering type information
Related to EDIT - bug #10138: Details view is not updated after freetext change
Related to EDIT - bug #10054: Changes on secundum reference are lost after ch...
Related to EDIT - bug #10053: Problems with saving of secundum references
Related to EDIT - task #10187: Use only 1 service call to initialize suppleme...
Related to EDIT - bug #7699: NPE in CdmTransientEntityCacher.getCacheElement()
Related to EDIT - bug #10214: Cache configuration for term cache not correctl...
Related to EDIT - bug #8953: Focus not correctly evaluated for details view w...
Related to EDIT - bug #10068: Changing focus to accepted taxon does not work
Related to EDIT - feature request #6554: The details views are newly created ...
Associated revisions

Revision fea04d02 - 11/16/2022 01:31 PM - Katja Luther

use cached terms also for uuid list

Revision fa600854 - 11/17/2022 02:41 PM - Katja Luther

ref #10186: setSelection in setFocus is not necessary

Revision 8180822f - 11/18/2022 10:57 AM - Andreas Miiller

ref #10186 remove ConversationHolder from many forms and some more cleanup

Revision 154d4fe7 - 11/18/2022 11:25 AM - Andreas Miiller

ref #10186 remove ConversationHolder from many forms and some more cleanup (cont.)

Revision 49d3c2dd - 11/18/2022 05:56 PM - Katja Luther

ref #10186: remove conversation holder

Revision d3cfcce0 - 11/18/2022 05:59 PM - Katja Luther

ref #10186: remove datachangeBehaviour classes

Revision 25¢3d160 - 11/18/2022 06:05 PM - Katja Luther

ref #10186: remove conversation holder - continue

Revision eab688c3 - 11/21/2022 11:28 AM - Katja Luther
ref #10186: code cleaning

Revision Ocaafa75 - 11/21/2022 11:53 AM - Andreas Miiller

ref #10186 further remove ConversationHolder and cleanup
Revision 4c980025 - 11/24/2022 02:18 PM - Andreas Miiller

ref #10186 further remove ConversationHolder from TaxEditor code and some cleanup

Revision 29dea790 - 11/24/2022 02:49 PM - Andreas Miiller

ref #10186 further remove ConversationHolder from TaxEditor code and some cleanup (cont.)

Revision dad85080 - 11/27/2022 12:18 AM - Andreas Miiller

ref #10186 fix incorrect delaySelection handling for equal previous selection (and remove some debugging)

Revision 20d52c89 - 11/27/2022 10:59 PM - Andreas Miiller

ref #10186 fix incorrect delaySelection handling for multiselect and no active Editor

Revision 674b745b - 11/30/2022 12:51 AM - Andreas Miiller
ref #10186, ref #9174 add method logging to CachingHttplnvokerProxyFactoryBean

Revision ec4e915f - 12/20/2022 03:23 PM - Andreas Miiller

ref #10186 fix incorrect isinDelay handling in SelectionDelay

History

#1 - 11/17/2022 02:35 PM - Katja Luther
- Related to bug #10111: Data loss e.g. when entering type information added

#2 - 11/17/2022 02:35 PM - Katja Luther
- Related to bug #10138: Details view is not updated after freetext change added

#3 - 11/17/2022 02:35 PM - Katja Luther

- Related to bug #10054: Changes on secundum reference are lost after changing status to basionym added

#4 - 11/17/2022 02:36 PM - Katja Luther

- Related to bug #10053: Problems with saving of secundum references added

#5 - 11/18/2022 02:22 PM - Katja Luther

- Status changed from New to In Progress

Explaining the already cleaned up code:
SetSelection in setFocus of TaxonNameEditorE4 is not necessary and yields to a second call of the same method (TaxonNameEditorE4.setFocus()).

The TermComboboxes are filled with the terms defined by the preferences or with the whole list of terms of the related type. For the reduced list, the
find-call is done with a list of uuids and results alyways in a service call because in cacheTerms only listByTermType is handled.

Therefore the call of TermManager.getTerms(List, TermType) is changed in a way the terms are loaded from the TermStore and then filtered. Maybe
this handling can still be improved in any way. But actually the DB calls are reduced and the correct terms are shown also after changing the
preference.

The conversationHolder is a leftover from the times before remoting, so we removed it. Actually only a conversation mock was used.

#6 - 11/22/2022 03:10 PM - Andreas Miiller

- Related to task #10187: Use only 1 service call to initialize supplemental data added

#7 - 11/23/2022 12:29 PM - Andreas Miiller

A critical issue: In AbstractCdmEditorPartE4 line 182 it is checked if (new) selection equals the previous selection. But this does not take into account
that the selection may still change in an already added "sync.asyncExec(delaySelection);" call which is in the pipeline. So the latest focus/selection
change may be swollowed by this check, however, the focus may be in the new position while the selection in the view-to-be-updated may later
change to the selection previously selected and asynchronously called.

This is only the case when setting the focus back and forth between 2 different selections.

#8 - 11/28/2022 12:04 PM - Andreas Miiller
- % Done changed from 0 to 20

Andreas Muller wrote in #note-7:
A critical issue: In AbstractCdmEditorPartE4 line 182 it is checked if (new) selection equals the previous selection. But this does not take into
account that the selection may still change in an already added "sync.asyncExec(delaySelection);" call which is in the pipeline. So the latest
focus/selection change may be swollowed by this check, however, the focus may be in the new position while the selection in the
view-to-be-updated may later change to the selection previously selected and asynchronously called.

This is only the case when setting the focus back and forth between 2 different selections.

This should be fixed now with dad85080 and 20d52¢89 . The result looks as far as now the focus and the selected data in the views seems to be
always the same if one waits until the views have all loaded, even if you clicked before multiple times on different selections. However, it still needs
intensive testing before being released.

#9 - 11/30/2022 09:54 AM - Andreas Miiller
- Related to bug #7699: NPE in CdmTransientEntityCacher.getCacheElement() added

#10 - 12/16/2022 02:25 PM - Andreas Miiller

Katja Luther wrote in #note-5:

SetSelection in setFocus of TaxonNameEditorE4 is not necessary and yields to a second call of the same method
(TaxonNameEditorE4.setFocus()).

Does this need to be fixed also in other Editors like Term Editor?

#11 - 12/21/2022 01:13 PM - Andreas Miiller

- Related to bug #10214: Cache configuration for term cache not correctly initialized in taxeditor added

#12 - 01/05/2023 02:58 PM - Katja Luther

Andreas Muller wrote in #note-10:

Katja Luther wrote in #note-5:

SetSelection in setFocus of TaxonNameEditorE4 is not necessary and yields to a second call of the same method
(TaxonNameEditorE4.setFocus()).

Does this need to be fixed also in other Editors like Term Editor?

In setFocus of termEditor there is no setSelected call also in Bulkeditor, DescriptiveDatasetEditor and others. This was a special case because of the
containers of the taxon editor

#13 - 01/05/2023 03:00 PM - Andreas Miiller

- Related to bug #8953: Focus not correctly evaluated for details view when switching between names added

#14 - 01/05/2023 03:01 PM - Andreas Miiller
- Related to bug #10068: Changing focus to accepted taxon does not work added

#15 - 01/05/2023 03:12 PM - Andreas Miiller
- Status changed from In Progress to Resolved

- % Done changed from 20 to 60

Should we close this ticket and open a new one if we do further research on taxeditor sessions? | think there are a couple of issues that were fixed
within this ticket or in related tickets opened during research.

#16 - 01/05/2023 03:17 PM - Katja Luther

- Status changed from Resolved to Closed

Further issues can be handled in the more detailed tickets.

#17 - 01/05/2023 05:45 PM - Andreas Miiller

- Related to feature request #6554: The details views are newly created with every change of the focus added

04/18/2024 3/3


http://www.tcpdf.org

